
**this file creates the variables for Z and income for the estimation in matlab
***water using fixtures
gen toilet=q1a
gen standpipe=q1b
gen bath=q1c
gen shower=q1d
gen btap=q1e
gen ktap=q1f

**water using appliances
gen wash=q2a
gen lawn=q2c
gen flower=q2d
gen vegetable=q2e

**irrigation
gen winteri=0
replace winteri=1 if q4>=2

gen summeri=0
replace summeri=1 if q5>=2 

gen carw=0
replace carw=1 if q6>=2 

**demographic characteristic
gen adult=q17a
gen teen=q17b
replace teen=0 if q17b==99
gen child=q17c
gen outside=q18

gen education=.
replace education=1 if q16a<4
replace education=2 if q16a==4
replace education=3 if q16a==5
replace education=4 if q16a==6
replace education=5 if q16a==7
tab education, gen(ed)

***For Table 1, Panel B
sum toilet standpipe bath shower ktap btap wash lawn flower vegetable winteri summeri carw ed1-ed5 adult teen child outside

***generating income variables
gen q19bnew=q19b
replace q19bnew=100 if q19b==1
replace q19bnew=300 if q19b==2
replace q19bnew=500 if q19b==3
replace q19bnew=700 if q19b==4
replace q19bnew=900 if q19b==5
replace q19bnew=1100 if q19b==6
replace q19bnew=1300 if q19b==7
replace q19bnew=1500 if q19b==8
replace q19bnew=1700 if q19b==9
replace q19bnew=1900 if q19b==10
replace q19bnew=2100 if q19b==11
replace q19bnew=2300 if q19b==12
replace q19bnew=2500 if q19b==13
replace q19bnew=2700 if q19b==14
replace q19bnew=2900 if q19b==15
replace q19bnew=3100 if q19b==16
replace q19bnew=3300 if q19b==17
replace q19bnew=3500 if q19b==18
replace q19bnew=3700 if q19b==19
replace q19bnew=4250 if q19b==20
replace q19bnew=4750 if q19b==21
replace q19bnew=5500 if q19b==22
replace q19bnew=6500 if q19b==23
replace q19bnew=7500 if q19b==24
replace q19bnew=8500 if q19b==25
replace q19bnew=9500 if q19b==26
replace q19bnew=10500 if q19b==27
replace q19bnew=11500 if q19b==28
replace q19bnew=13000 if q19b==29
replace q19bnew=15000 if q19b==30
replace q19bnew=17000 if q19b==31
replace q19bnew=19000 if q19b==32
replace q19bnew=20000 if q19b==33

gen income=q19a
replace income=q19bnew if q19a==-4 & q19b<34
replace income=. if income==-4
label var income "respondent's income"

gen income2=income
replace income2=income2+q19c if q19c~=-4
replace income2=income2+q19d if q19d~=-4
replace income2=income2+q19e if q19e~=-4
label var income2 "respondent+additional earner's income based on the survey"

gen lnincome2=ln(income2)
egen g=group(q20a-q20f ed1-ed5 q18)
xi: reg lnincome2 i.g
predict income_newg
gen income_newg2=exp(income_newg)
sum income_newg2, det

drop _Ig_*
drop g

**we have 3 income variables in 2010 dollars
replace income=income/1.1139
replace income2=income2/1.1139
gen income6=income_newg2/1.1139
*for Table 8
sum income income2 income6 
sum income6 if income~=.

