
%read in the data
[data] = textread('data.csv','','delimiter',',','emptyvalue',NaN);

tyear=data(:,2);
y=data(:,3);
n=length(y);
X=[ones(n,1) data(:,4:12)];

inc=data(:,21);
ind=data(:,4);
rich=data(:,6); 

k=size(X,2);
%parameters from the maximum likelihood estimation
z=[2.11071384659238;0.364322010386021;0.343848517111769;4.78735441332822;0.196774695191232;0.0905645831176923;0.0527256528032570;0.0972003203417297;6.26074130958016;-0.120425446913677;-1.13853273664756;3.58054197016075e-05;0.0720547481702557;3.03865267604019;];

% read in baseline utility computed by baseline_utility.m 
[U0] = textread('Ubaseline.csv','','delimiter',',','emptyvalue',NaN);
options=optimset('Display','iter','TolFun',0.000001,'TolX',0.000001,'TypicalX',100000000);

%include the optimal price schedule computed before, see the 8 cases
%described in Readme.pdf
%include the optimal price schedule (7 segments) in the vector below
x=[ ];

U0=U0*1e+09;

for i=1:n
    bb0=-100;
    comp(i,1)=fsolve(@(bb) compensated2(bb,x,X(i,:),n,k,z,ind(i,1),inc(i,1),U0(i,1)), [bb0],options);
end

[m,grp]=grpstats(comp,ind,{'mean','gname'})
[m,grp]=grpstats(comp,ind,{'median','gname'})

