function [c,ceq] = constraint7i(x,X,n,k,z,ind,inc);

%x starting values for the marginal prices
%X data
%z parameters from the estimation

%include revenue/expenditure (R) and total consumpiton (CC)
%corresponding to the baseline tariff year (either tyear 6 or tyear 8)
%computed by current.m
R= ;
CC= ;


bc=z(1:k);
bp=z(k+1);
by=z(k+2);

sn=z(end-1)^2;  %sn: sigma(eta)
s0=z(end)^2;  %s0: sigma(epsilon
sv=sqrt((s0^2)+(sn^2));  %sv: sigma(v)
corr=sn/sv;  %corr: rho

p(:,1)=ones(n,1)*x(1);
for i=1:n
    if ind(i,1)==1
        p(i,1)=0;
    end
end
    
p(:,2)=ones(n,1)*(x(1)+x(2));
p(:,3)=ones(n,1)*(x(1)+x(2)+x(3));
p(:,4)=ones(n,1)*(x(1)+x(2)+x(3)+x(4));
p(:,5)=ones(n,1)*(x(1)+x(2)+x(3)+x(4)+x(5));
p(:,6)=ones(n,1)*(x(1)+x(2)+x(3)+x(4)+x(5)+x(6));
p(:,7)=ones(n,1)*(x(1)+x(2)+x(3)+x(4)+x(5)+x(6)+x(7));

w(:,1)=ones(n,1)*6;
w(:,2)=ones(n,1)*12;
w(:,3)=ones(n,1)*18;
w(:,4)=ones(n,1)*24;
w(:,5)=ones(n,1)*30;
w(:,6)=ones(n,1)*42;

inc=inc(:,1);
inc(:,2)=inc(:,1)+(p(:,2)-p(:,1)).*w(:,1);
inc(:,3)=inc(:,2)+(p(:,3)-p(:,2)).*w(:,2);
inc(:,4)=inc(:,3)+(p(:,4)-p(:,3)).*w(:,3);
inc(:,5)=inc(:,4)+(p(:,5)-p(:,4)).*w(:,4);
inc(:,6)=inc(:,5)+(p(:,6)-p(:,5)).*w(:,5);
inc(:,7)=inc(:,6)+(p(:,7)-p(:,6)).*w(:,6);

wstar1=X*bc+bp*(p(:,1))+by*inc(:,1);
wstar2=X*bc+bp*(p(:,2))+by*inc(:,2);
wstar3=X*bc+bp*(p(:,3))+by*inc(:,3);
wstar4=X*bc+bp*(p(:,4))+by*inc(:,4);
wstar5=X*bc+bp*(p(:,5))+by*inc(:,5);
wstar6=X*bc+bp*(p(:,6))+by*inc(:,6);
wstar7=X*bc+bp*(p(:,7))+by*inc(:,7);

% FEASIBILITY AND SEGMENT VS. SEGMENT THRESHOLDS (theta_jk and eta_jk)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

theta11=w(:,1)-wstar1;  %these are theta_ij
theta12=w(:,1)-wstar2;
theta22=w(:,2)-wstar2;
theta23=w(:,2)-wstar3;
theta33=w(:,3)-wstar3;
theta34=w(:,3)-wstar4;
theta44=w(:,4)-wstar4; 
theta45=w(:,4)-wstar5;
theta55=w(:,5)-wstar5;
theta56=w(:,5)-wstar6;
theta66=w(:,6)-wstar6;
theta67=w(:,6)-wstar7;


up1s=theta11;
lo1k=theta11;
up1k=theta12;
lo2s=theta12;
up2s=theta22;
lo2k=theta22;
up2k=theta23;
lo3s=theta23;
up3s=theta33;
lo3k=theta33;
up3k=theta34;
lo4s=theta34;
up4s=theta44;
lo4k=theta44;
up4k=theta45;
lo5s=theta45;
up5s=theta55;
lo5k=theta55;
up5k=theta56;
lo6s=theta56;
up6s=theta66;
lo6k=theta66;
up6k=theta67;
lo7s=theta67;

wstar=[wstar1 wstar2 wstar3 wstar4 wstar5 wstar6 wstar7 ];

trunc=nanmin(-wstar,[],2)-bp/by; % trunc is etabar
tr2=normcdf(trunc/sn,0,1)+0.0000000001; %add small number to avoid dividing by zero below

pik=zeros(n,7); %the probability of each segment
zeta=zeros(n,7); %the expected consumption on each segment
lambda=zeros(n,7); %the probability of each kink

for i=1:n    
    pik(i,1)=normcdf(min(up1s(i,1),trunc(i,1))/sn)/tr2(i,1);
    pik(i,2)=max(0,(normcdf(min(up2s(i,1),trunc(i,1))/sn)-normcdf(min(lo2s(i,1),trunc(i,1))/sn)))/tr2(i,1);
    pik(i,3)=max(0,(normcdf(min(up3s(i,1),trunc(i,1))/sn)-normcdf(min(lo3s(i,1),trunc(i,1))/sn)))/tr2(i,1);
    pik(i,4)=max(0,(normcdf(min(up4s(i,1),trunc(i,1))/sn)-normcdf(min(lo4s(i,1),trunc(i,1))/sn)))/tr2(i,1);
    pik(i,5)=max(0,(normcdf(min(up5s(i,1),trunc(i,1))/sn)-normcdf(min(lo5s(i,1),trunc(i,1))/sn)))/tr2(i,1);
    pik(i,6)=max(0,(normcdf(min(up6s(i,1),trunc(i,1))/sn)-normcdf(min(lo6s(i,1),trunc(i,1))/sn)))/tr2(i,1);
    pik(i,7)=1-normcdf(min(lo7s(i,1),trunc(i,1))/sn)/tr2(i,1);
     
    lambda(i,1)=max(0,normcdf(min(up1k(i,1),trunc(i,1))/sn)-normcdf(min(lo1k(i,1),trunc(i,1))/sn))/tr2(i,1);
    lambda(i,2)=max(0,normcdf(min(up2k(i,1),trunc(i,1))/sn)-normcdf(min(lo2k(i,1),trunc(i,1))/sn))/tr2(i,1);
    lambda(i,3)=max(0,normcdf(min(up3k(i,1),trunc(i,1))/sn)-normcdf(min(lo3k(i,1),trunc(i,1))/sn))/tr2(i,1);
    lambda(i,4)=max(0,normcdf(min(up4k(i,1),trunc(i,1))/sn)-normcdf(min(lo4k(i,1),trunc(i,1))/sn))/tr2(i,1);
    lambda(i,6)=max(0,normcdf(min(up6k(i,1),trunc(i,1))/sn)-normcdf(min(lo6k(i,1),trunc(i,1))/sn))/tr2(i,1);
%     
    zeta(i,1)=-normpdf(min(up1s(i,1),trunc(i,1))/sn)/pik(i,1)/tr2(i,1)*sn;
    zeta(i,2)=(normpdf(min(lo2s(i,1),trunc(i,1))/sn)-normpdf(min(up2s(i,1),trunc(i,1))/sn))/pik(i,2)/tr2(i,1)*sn;
    zeta(i,3)=(normpdf(min(lo3s(i,1),trunc(i,1))/sn)-normpdf(min(up3s(i,1)/sn,trunc(i,1))/sn))/pik(i,3)/tr2(i,1)*sn;
    zeta(i,4)=(normpdf(min(lo4s(i,1),trunc(i,1))/sn)-normpdf(min(up4s(i,1)/sn,trunc(i,1))/sn))/pik(i,4)/tr2(i,1)*sn;
    zeta(i,5)=(normpdf(min(lo5s(i,1),trunc(i,1))/sn)-normpdf(min(up5s(i,1)/sn,trunc(i,1))/sn))/pik(i,5)/tr2(i,1)*sn;
    zeta(i,6)=(normpdf(min(lo6s(i,1),trunc(i,1))/sn)-normpdf(min(up6s(i,1)/sn,trunc(i,1))/sn))/pik(i,6)/tr2(i,1)*sn;
    zeta(i,7)=(normpdf(min(lo7s(i,1),trunc(i,1))/sn)-normpdf(trunc(i,1)/sn))/pik(i,7)/tr2(i,1)*sn;
    
    W1(i,1)=(wstar1(i,1)+zeta(i,1)).*pik(i,1);
    W2(i,1)=(wstar2(i,1)+zeta(i,2)).*pik(i,2);
    W3(i,1)=(wstar3(i,1)+zeta(i,3)).*pik(i,3);
    W4(i,1)=(wstar4(i,1)+zeta(i,4)).*pik(i,4);
    W5(i,1)=(wstar5(i,1)+zeta(i,5)).*pik(i,5);
    W6(i,1)=(wstar6(i,1)+zeta(i,6)).*pik(i,6);
    W7(i,1)=(wstar7(i,1)+zeta(i,7)).*pik(i,7);
    
    W1k(i,1)=w(i,1).*lambda(i,1);
    W2k(i,1)=w(i,2).*lambda(i,2);
    W3k(i,1)=w(i,3).*lambda(i,3);
    W4k(i,1)=w(i,4).*lambda(i,4);
    W5k(i,1)=w(i,5).*lambda(i,5);
    W6k(i,1)=w(i,6).*lambda(i,6);
%    

end


%NaN's are possible in W when a segment / kink has 0 probability.
%Therefore, we replace these with 0.
null=isnan(W1);
W1(null)=0;
null=isnan(W2);
W2(null)=0;
null=isnan(W3);
W3(null)=0;
null=isnan(W4);
W4(null)=0;
null=isnan(W5);
W5(null)=0;
null=isnan(W6);
W6(null)=0;
null=isnan(W7);
W7(null)=0;

null=isnan(W1k);
W1k(null)=0;
null=isnan(W2k);
W2k(null)=0;
null=isnan(W3k);
W3k(null)=0;
null=isnan(W4k);
W4k(null)=0;
null=isnan(W5k);
W5k(null)=0;
null=isnan(W6k);
W6k(null)=0;

W=W1+W2+W3+W4+W5+W6+W7+W1k+W2k+W3k+W4k+W5k+W6k;
WW=sum(W);

C1=WW-CC;

ex1=zeros(n,1);
ex2=zeros(n,1);
ex3=zeros(n,1);
ex4=zeros(n,1);
ex5=zeros(n,1);
ex6=zeros(n,1);
ex7=zeros(n,1);


for i=1:n
ex7(i,1)=max(0,W(i)-w(i,6));
ex6(i,1)=max(0,W(i)-ex7(i,1)-w(i,5));
ex5(i,1)=max(0,W(i)-ex7(i,1)-ex6(i,1)-w(i,4));
ex4(i,1)=max(0,W(i)-ex7(i,1)-ex6(i,1)-ex5(i,1)-w(i,3));
ex3(i,1)=max(0,W(i)-ex7(i,1)-ex6(i,1)-ex5(i,1)-ex4(i,1)-w(i,2));
ex2(i,1)=max(0,W(i)-ex7(i,1)-ex6(i,1)-ex5(i,1)-ex4(i,1)-ex3(i,1)-w(i,1));
ex1(i,1)=max(0,W(i)-ex7(i,1)-ex6(i,1)-ex5(i,1)-ex4(i,1)-ex3(i,1)-ex2(i,1));
end


EX=p(:,1).*ex1+p(:,2).*ex2+p(:,3).*ex3+p(:,4).*ex4+p(:,5).*ex5+p(:,6).*ex6+p(:,7).*ex7;

%change the marginal cost here: 4 or 8.2
c(1)=R+8.2*(WW-CC)-sum(EX);


ceq=[];



