
%once the parameters are estimated, run the entire code in "likelihood.m" to compute the necessary values with the parameter estimates.
%then, run the following:

pik=zeros(n,8); %the probability of each segment
pika=zeros(n,8); %the alternative probability of each segment
zeta=zeros(n,8); %the expected consumption on each segment
zetaa=zeros(n,8);
lambda=zeros(n,8); %the probability of each kink
lambdaa=zeros(n,8);

for i=1:n
    
    pik(i,1)=normcdf(min(up1s(i,1),trunc(i,1))/sn)/tr2(i,1);
    pik(i,2)=max(0,(normcdf(min(up2s(i,1),trunc(i,1))/sn)-normcdf(min(lo2s(i,1),trunc(i,1))/sn)))/tr2(i,1);
    pik(i,3)=max(0,(normcdf(min(up3s(i,1),trunc(i,1))/sn)-normcdf(min(lo3s(i,1),trunc(i,1))/sn)))/tr2(i,1);
    pik(i,4)=max(0,(normcdf(min(up4s(i,1),trunc(i,1))/sn)-normcdf(min(lo4s(i,1),trunc(i,1))/sn)))/tr2(i,1);
    pik(i,5)=max(0,(normcdf(min(up5s(i,1),trunc(i,1))/sn)-normcdf(min(lo5s(i,1),trunc(i,1))/sn)))/tr2(i,1);
    pik(i,6)=max(0,(normcdf(min(up6s(i,1),trunc(i,1))/sn)-normcdf(min(lo6s(i,1),trunc(i,1))/sn)))/tr2(i,1);
    if rich(i)==0 && (tyear(i)==5 || tyear(i)==6)
        pik(i,7)=0;
    else
        pik(i,7)=max(0,(normcdf(min(up7s(i,1),trunc(i,1))/sn)-normcdf(min(lo7s(i,1),trunc(i,1))/sn)))/tr2(i,1);
    end
    if tyear(i)<=3 || (rich(i)==0 && (tyear(i)==5 || tyear(i)==6))
        pik(i,8)=0;
    else
        pik(i,8)=1-normcdf(min(lo8s(i,1),trunc(i,1))/sn)/tr2(i,1);
    end
    
    
    lambda(i,1)=max(0,normcdf(min(up1k(i,1),trunc(i,1))/sn)-normcdf(min(lo1k(i,1),trunc(i,1))/sn))/tr2(i,1);
    lambda(i,2)=max(0,normcdf(min(up2k(i,1),trunc(i,1))/sn)-normcdf(min(lo2k(i,1),trunc(i,1))/sn))/tr2(i,1);
    lambda(i,3)=max(0,normcdf(min(up3k(i,1),trunc(i,1))/sn)-normcdf(min(lo3k(i,1),trunc(i,1))/sn))/tr2(i,1);
    lambda(i,4)=max(0,normcdf(min(up4k(i,1),trunc(i,1))/sn)-normcdf(min(lo4k(i,1),trunc(i,1))/sn))/tr2(i,1);
    if rich(i)==0 && (tyear(i)==5 || tyear(i)==6)
        lambda(i,6)=0;
    else
        lambda(i,6)=max(0,normcdf(min(up6k(i,1),trunc(i,1))/sn)-normcdf(min(lo6k(i,1),trunc(i,1))/sn))/tr2(i,1);
    end
    if tyear(i)<=3 || (rich(i)==0 && (tyear(i)==5 || tyear(i)==6))
        lambda(i,7)=0;
    else
        lambda(i,7)=max(0,normcdf(min(up7k(i,1),trunc(i,1))/sn)-normcdf(min(lo7k(i,1),trunc(i,1))/sn))/tr2(i,1);
    end
    
    pika(i,2)=max(0,(normcdf(min(up2sa(i,1),trunc(i,1))/sn)-normcdf(min(lo2sa(i,1),trunc(i,1))/sn)))/tr2(i,1);
    pika(i,3)=max(0,(normcdf(min(up3sa(i,1),trunc(i,1))/sn)-normcdf(min(lo3sa(i,1),trunc(i,1))/sn)))/tr2(i,1);
    pika(i,4)=max(0,(normcdf(min(up4sa(i,1),trunc(i,1))/sn)-normcdf(min(lo4sa(i,1),trunc(i,1))/sn)))/tr2(i,1);
    pika(i,5)=max(0,(normcdf(min(up5sa(i,1),trunc(i,1))/sn)-normcdf(min(lo5sa(i,1),trunc(i,1))/sn)))/tr2(i,1);
    pika(i,6)=max(0,(normcdf(min(up6sa(i,1),trunc(i,1))/sn)-normcdf(min(lo6sa(i,1),trunc(i,1))/sn)))/tr2(i,1);
    if rich(i)==0 && (tyear(i)==5 || tyear(i)==6)
        pika(i,7)=0;
    else
        pika(i,7)=max(0,(normcdf(min(up7sa(i,1),trunc(i,1))/sn)-normcdf(min(lo7sa(i,1),trunc(i,1))/sn)))/tr2(i,1);
    end
    
    lambdaa(i,1)=max(0,normcdf(min(up1ka(i,1),trunc(i,1))/sn)-normcdf(min(lo1ka(i,1),trunc(i,1))/sn))/tr2(i,1);
    lambdaa(i,2)=max(0,normcdf(min(up2ka(i,1),trunc(i,1))/sn)-normcdf(min(lo2ka(i,1),trunc(i,1))/sn))/tr2(i,1);
    lambdaa(i,3)=max(0,normcdf(min(up3ka(i,1),trunc(i,1))/sn)-normcdf(min(lo3ka(i,1),trunc(i,1))/sn))/tr2(i,1);
    lambdaa(i,4)=max(0,normcdf(min(up4ka(i,1),trunc(i,1))/sn)-normcdf(min(lo4ka(i,1),trunc(i,1))/sn))/tr2(i,1);
    if rich(i)==0 && (tyear(i)==5 || tyear(i)==6)
        lambdaa(i,6)=0;
    else
        lambdaa(i,6)=max(0,normcdf(min(up6ka(i,1),trunc(i,1))/sn)-normcdf(min(lo6ka(i,1),trunc(i,1))/sn))/tr2(i,1);
    end
    if tyear(i)<=3 || (rich(i)==0 && (tyear(i)==5 || tyear(i)==6))
        lambdaa(i,7)=0;
    else
        lambdaa(i,7)=max(0,normcdf(min(up7ka(i,1),trunc(i,1))/sn)-normcdf(min(lo7ka(i,1),trunc(i,1))/sn))/tr2(i,1);
    end
    
    zeta(i,1)=-normpdf(min(up1s(i,1),trunc(i,1))/sn)/pik(i,1)/tr2(i,1)*sn;
    zeta(i,2)=(normpdf(min(lo2s(i,1),trunc(i,1))/sn)-normpdf(min(up2s(i,1),trunc(i,1))/sn))/pik(i,2)/tr2(i,1)*sn;
    zeta(i,3)=(normpdf(min(lo3s(i,1),trunc(i,1))/sn)-normpdf(min(up3s(i,1)/sn,trunc(i,1))/sn))/pik(i,3)/tr2(i,1)*sn;
    zeta(i,4)=(normpdf(min(lo4s(i,1),trunc(i,1))/sn)-normpdf(min(up4s(i,1)/sn,trunc(i,1))/sn))/pik(i,4)/tr2(i,1)*sn;
    zeta(i,5)=(normpdf(min(lo5s(i,1),trunc(i,1))/sn)-normpdf(min(up5s(i,1)/sn,trunc(i,1))/sn))/pik(i,5)/tr2(i,1)*sn;
    zeta(i,6)=(normpdf(min(lo6s(i,1),trunc(i,1))/sn)-normpdf(min(up6s(i,1)/sn,trunc(i,1))/sn))/pik(i,6)/tr2(i,1)*sn;
    if rich(i)==0 && (tyear(i)==5 || tyear(i)==6)
        zeta(i,7)=0;
    else
        zeta(i,7)=(normpdf(min(lo7s(i,1),trunc(i,1))/sn)-normpdf(min(up7s(i,1),trunc(i,1))/sn))/pik(i,7)/tr2(i,1)*sn;
    end
    if tyear(i)<=3 || (rich(i)==0 && (tyear(i)==5 || tyear(i)==6))
        zeta(i,8)=0;
    else
        zeta(i,8)=(normpdf(min(lo8s(i,1),trunc(i,1))/sn)-normpdf(trunc(i,1)/sn))/pik(i,8)/tr2(i,1)*sn;
    end
    
    zetaa(i,2)=(normpdf(min(lo2sa(i,1),trunc(i,1))/sn)-normpdf(min(up2sa(i,1),trunc(i,1))/sn))/pika(i,2)/tr2(i,1)*sn;
    zetaa(i,3)=(normpdf(min(lo3sa(i,1),trunc(i,1))/sn)-normpdf(min(up3sa(i,1),trunc(i,1))/sn))/pika(i,3)/tr2(i,1)*sn;
    zetaa(i,4)=(normpdf(min(lo4sa(i,1),trunc(i,1))/sn)-normpdf(min(up4sa(i,1),trunc(i,1))/sn))/pika(i,4)/tr2(i,1)*sn;
    zetaa(i,5)=(normpdf(min(lo5sa(i,1),trunc(i,1))/sn)-normpdf(min(up5sa(i,1),trunc(i,1))/sn))/pika(i,5)/tr2(i,1)*sn;
    zetaa(i,6)=(normpdf(min(lo6sa(i,1),trunc(i,1))/sn)-normpdf(min(up6sa(i,1),trunc(i,1))/sn))/pika(i,6)/tr2(i,1)*sn;
    if rich(i)==0 && (tyear(i)==5 || tyear(i)==6)
        zetaa(i,7)=0;
    else
        zetaa(i,7)=(normpdf(min(lo7sa(i,1),trunc(i,1))/sn)-normpdf(min(up7sa(i,1),trunc(i,1))/sn))/pika(i,7)/tr2(i,1)*sn;
    end
    
end

checkprob=sum(pik,2)+sum(pika,2)+sum(lambda,2)+sum(lambdaa,2); % this should be all 1-s

for i=1:n
W1(i,1)=(wstar1(i,1)+zeta(i,1)).*pik(i,1);
W2(i,1)=(wstar2(i,1)+zeta(i,2)).*pik(i,2);
W3(i,1)=(wstar3(i,1)+zeta(i,3)).*pik(i,3);
W4(i,1)=(wstar4(i,1)+zeta(i,4)).*pik(i,4);
W5(i,1)=(wstar5(i,1)+zeta(i,5)).*pik(i,5);
W6(i,1)=(wstar6(i,1)+zeta(i,6)).*pik(i,6);
W7(i,1)=(wstar7(i,1)+zeta(i,7)).*pik(i,7);
W8(i,1)=(wstar8(i,1)+zeta(i,8)).*pik(i,8);
W1k(i,1)=w(i,1).*lambda(i,1);
W2k(i,1)=w(i,2).*lambda(i,2);
W3k(i,1)=w(i,3).*lambda(i,3);
W4k(i,1)=w(i,4).*lambda(i,4);
W5k(i,1)=w(i,5).*lambda(i,5);
W6k(i,1)=w(i,6).*lambda(i,6);
W7k(i,1)=w(i,7).*lambda(i,7);

end

W2a=zeros(n,1);
W3a=zeros(n,1);
W4a=zeros(n,1);
W5a=zeros(n,1);
W6a=zeros(n,1);
W7a=zeros(n,1);
W8a=zeros(n,1);
W2ak=zeros(n,1);
W3ak=zeros(n,1);
W4ak=zeros(n,1);
W5ak=zeros(n,1);
W6ak=zeros(n,1);
W7ak=zeros(n,1);

for i=1:n
    if rich(i,1)==1
W2a(i,1)=(wstar2(i,1)+zetaa(i,2)).*pika(i,2);
W3a(i,1)=(wstar3(i,1)+zetaa(i,3)).*pika(i,3);
W4a(i,1)=(wstar4(i,1)+zetaa(i,4)).*pika(i,4);
W5a(i,1)=(wstar5(i,1)+zetaa(i,5)).*pika(i,5);
W6a(i,1)=(wstar6(i,1)+zetaa(i,6)).*pika(i,6);
W7a(i,1)=(wstar7(i,1)+zetaa(i,7)).*pika(i,7);
W8a(i,1)=(wstar8(i,1)+zetaa(i,8)).*pika(i,8);
W2ak(i,1)=w(i,2).*lambdaa(i,2);
W3ak(i,1)=w(i,3).*lambdaa(i,3);
W4ak(i,1)=w(i,4).*lambdaa(i,4);
W5ak(i,1)=w(i,5).*lambdaa(i,5);
W6ak(i,1)=w(i,6).*lambdaa(i,6);
W7ak(i,1)=w(i,7).*lambdaa(i,7);

    end
end


null=isnan(W1);
W1(null)=0;
null=isnan(W2);
W2(null)=0;
null=isnan(W3);
W3(null)=0;
null=isnan(W4);
W4(null)=0;
null=isnan(W5);
W5(null)=0;
null=isnan(W6);
W6(null)=0;
null=isnan(W7);
W7(null)=0;
null=isnan(W8);
W8(null)=0;

null=isnan(W1k);
W1k(null)=0;
null=isnan(W2k);
W2k(null)=0;
null=isnan(W3k);
W3k(null)=0;
null=isnan(W4k);
W4k(null)=0;
null=isnan(W5k);
W5k(null)=0;
null=isnan(W6k);
W6k(null)=0;
null=isnan(W7k);
W7k(null)=0;

null=isnan(W2a);
W2a(null)=0;
null=isnan(W3a);
W3a(null)=0;
null=isnan(W4a);
W4a(null)=0;
null=isnan(W5a);
W5a(null)=0;
null=isnan(W6a);
W6a(null)=0;
null=isnan(W7a);
W7a(null)=0;
null=isnan(W8a);
W8a(null)=0;

null=isnan(W2ak);
W2ak(null)=0;
null=isnan(W3ak);
W3ak(null)=0;
null=isnan(W4ak);
W4ak(null)=0;
null=isnan(W5ak);
W5ak(null)=0;
null=isnan(W6ak);
W6ak(null)=0;
null=isnan(W7ak);
W7ak(null)=0;

W=(W1+W2+W3+W4+W5+W6+W7+W8+W2a+W3a+W4a+W5a+W6a+W7a+W8a+W1k+W2k+W3k+W4k+W5k+W6k+W7k+W2ak+W3ak+W4ak+W5ak+W6ak+W7ak); %individual expected consumption
performance=y-W; %model performance
