*For Table 5 household consumption and expenditure changes in a counterfactual scenario
*Run on "a.xls" which is generated by each counterfactual scenario as described in counterfactul1.m and counterfactual2.m. 

ren var1 y
label var y "observed consumption"
ren var2 W
label var W "expected consumption based on the model with observed prices"
ren var3 wco1
label var wco1 "expected consumption in counterfactual"

ren var4 ind
ren var5 rest
ren var6 rich
ren var7 tyear

*kiloliter at the kink points
ren var8 w1
ren var9 w2
ren var10 w3
ren var11 w4
ren var12 w5
ren var13 w6 
ren var14 w7

*counterfactual prices on block i, e.g. p11 is the marginal price for block1
ren var15 p11
ren var16 p22
ren var17 p33
ren var18 p44
ren var19 p55
ren var20 p66
ren var21 p77 
ren var22 p88


**observed marginal prices on block i, e.g. p1 is the marginal price for block 1
ren var23 p1
ren var24 p2
ren var25 p3
ren var26 p4
ren var27 p5
ren var28 p6
ren var29 p7
ren var30 p8


format   %9.3f W wco1
drop if tyear>6

sum y W wco1, format
sum y W wco1 if  ind==1, format
sum y W wco1 if ind==0, format

sum y W wco1 if  rest==1, format
sum y W wco1 if  rest==0, format

sum y W wco1 if rich==1, format
sum y W wco1 if  ind==1 & rich==1, format
sum y W wco1 if ind==0 & rich==1, format

sum y W wco1 if  rest==1 & rich==1, format
sum y W wco1 if  rest==0 & rich==1, format

**compute expenditure changes
**counterfactual without free water
ren wco1 w
gen w7x=w7
replace w7x=100 if w7x==.
gen p8x=p8
replace p8x=0 if p8x==.
gen p7x=p7
replace p7x=0 if p7x==.
gen w6x=w6
replace w6x=100 if w6x==.
gen ex8=max(0,w-w7x)
gen ex7=max(0,w-ex8-w6x)
gen ex6=max(0,w-ex8-ex7-w5)
gen ex5=max(0,w-ex8-ex7-ex6-w4)
gen ex4=max(0,w-ex8-ex7-ex6-ex5-w3)
gen ex3=max(0,w-ex8-ex7-ex6-ex5-ex4-w2)
gen ex2=max(0,w-ex8-ex7-ex6-ex5-ex4-ex3-w1)
gen ex1=max(0,w-ex8-ex7-ex6-ex5-ex4-ex3-ex2)
gen expco=p11*ex1+p22*ex2+p3*ex3+p4*ex4+p5*ex5+p6*ex6+p7x*ex7+p8x*ex8
label var expco "expenditure under counterfactual prices and consumption"
drop w7x p8x p7x w6x ex8-ex1
ren w wco1

**now with free water as in the data
ren W w
gen w7x=w7
replace w7x=100 if w7x==.
gen p8x=p8
replace p8x=0 if p8x==.
gen p7x=p7
replace p7x=0 if p7x==.
gen w6x=w6
replace w6x=100 if w6x==.
gen ex8=max(0,w-w7x)
gen ex7=max(0,w-ex8-w6x)
gen ex6=max(0,w-ex8-ex7-w5)
gen ex5=max(0,w-ex8-ex7-ex6-w4)
gen ex4=max(0,w-ex8-ex7-ex6-ex5-w3)
gen ex3=max(0,w-ex8-ex7-ex6-ex5-ex4-w2)
gen ex2=max(0,w-ex8-ex7-ex6-ex5-ex4-ex3-w1)
gen ex1=max(0,w-ex8-ex7-ex6-ex5-ex4-ex3-ex2)
gen exp=p1*ex1+p2*ex2+p3*ex3+p4*ex4+p5*ex5+p6*ex6+p7x*ex7+p8x*ex8
label var exp "expenditure under observed prices"
drop w7x p8x p7x w6x ex8-ex1
ren w W

**summary statistics for table
format   %9.3f exp expco

sum exp expco, format
sum exp expco if  ind==1, format
sum exp expco if ind==0, format
sum exp expco if  rest==1, format
sum exp expco if  rest==0, format

