%marginal effects
%overall marginal effects: Table 9, third and fourth columns
%marginal effects by group: Online Appendix

%W is expected consumption, computed in expected_consumption.m

%Start with continuos variables
%%maxt
maxte=standarderrors(x,y,[X(:,1:4) X(:,5)+1 X(:,6:10)],n,k,w,p,inc,tyear,ind,rich)-W;

mean(maxte)
[m,grp]=grpstats(maxte,ind,{'mean','gname'})
[m,grp]=grpstats(maxte,rest,{'mean','gname'})

%standard error of the marginal effects
sedata=[ind rest maxte];

[bootstat,bootsam]=bootstrp(100,@(x) [mean(x(:,3))],sedata);
std(bootstat)
[bootstat,bootsam]=bootstrp(100,@(x)[grpstats(x(:,3),x(:,1),{'mean'})],sedata);
std(bootstat)
[bootstat,bootsam]=bootstrp(100,@(x)[grpstats(x(:,3),x(:,2),{'mean'})],sedata);
std(bootstat)
 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%number of people on the property
nupersone=standarderrors(x,y,[X(:,1:6) X(:,7)+1 X(:,8:10)],n,k,w,p,inc,tyear,ind,rich)-W;
beep;

mean(nupersone)
[m,grp]=grpstats(nupersone,ind,{'mean','gname'})
[m,grp]=grpstats(nupersone,rest,{'mean','gname'})

sedata=[ind rest nupersone];
[bootstat,bootsam]=bootstrp(100,@(x) [mean(x(:,3))],sedata);
std(bootstat)
[bootstat,bootsam]=bootstrp(100,@(x)[grpstats(x(:,3),x(:,1),{'mean'})],sedata);
std(bootstat)
[bootstat,bootsam]=bootstrp(100,@(x)[grpstats(x(:,3),x(:,2),{'mean'})],sedata);
std(bootstat)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%outdoor water usage
outdoore=standarderrors(x,y,[X(:,1:7) X(:,8)+1 X(:,9:10)],n,k,w,p,inc,tyear,ind,rich)-W;
beep

mean(outdoore)
[m,grp]=grpstats(outdoore,ind,{'mean','gname'})
[m,grp]=grpstats(outdoore,rest,{'mean','gname'})

sedata=[ind rest outdoore];
[bootstat,bootsam]=bootstrp(100,@(x) [mean(x(:,3))],sedata);
std(bootstat)
[bootstat,bootsam]=bootstrp(100,@(x)[grpstats(x(:,3),x(:,1),{'mean'})],sedata);
std(bootstat)
[bootstat,bootsam]=bootstrp(100,@(x)[grpstats(x(:,3),x(:,2),{'mean'})],sedata);
std(bootstat)

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%Binary variables
%%ind
tic;
inde=standarderrors(x,y,[X(:,1) ones(n,1) X(:,3:10) ],n,k,w,p,inc,tyear,ones(n,1),rich)-standarderrors(x,y,[X(:,1) zeros(n,1) X(:,3:10) ],n,k,w,p,inc,tyear,zeros(n,1),rich);
beep;
toc;

mean(inde)
[m,grp]=grpstats(inde,ind,{'mean','gname'})
[m,grp]=grpstats(inde,rest,{'mean','gname'})

sedata=[ind rest inde];
[bootstat,bootsam]=bootstrp(100,@(x) [mean(x(:,3))],sedata);
std(bootstat)
[bootstat,bootsam]=bootstrp(100,@(x)[grpstats(x(:,3),x(:,1),{'mean'})],sedata);
std(bootstat)
[bootstat,bootsam]=bootstrp(100,@(x)[grpstats(x(:,3),x(:,2),{'mean'})],sedata);
std(bootstat)

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%restricted 
reste=standarderrors(x,y,[X(:,1:2) ones(n,1) X(:,4:10) ],n,k,w,p,inc,tyear,ind,rich)-standarderrors(x,y,[X(:,1:2) zeros(n,1) X(:,4:10)],n,k,w,p,inc,tyear,ind,rich);
beep;

mean(reste)
[m,grp]=grpstats(reste,ind,{'mean','gname'})
[m,grp]=grpstats(reste,rest,{'mean','gname'})

sedata=[ind rest reste];
[bootstat,bootsam]=bootstrp(100,@(x) [mean(x(:,3))],sedata);
std(bootstat)
[bootstat,bootsam]=bootstrp(100,@(x)[grpstats(x(:,3),x(:,1),{'mean'})],sedata);
std(bootstat)
[bootstat,bootsam]=bootstrp(100,@(x)[grpstats(x(:,3),x(:,2),{'mean'})],sedata);
std(bootstat)

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%rich
riche=standarderrors(x,y,[X(:,1:3) ones(n,1) X(:,5:10) ],n,k,w,p,inc,tyear,ind,ones(n,1))-standarderrors(x,y,[X(:,1:3) zeros(n,1) X(:,5:10) ],n,k,w,p,inc,tyear,ind,zeros(n,1));
beep;

mean(riche)
[m,grp]=grpstats(riche,ind,{'mean','gname'})
[m,grp]=grpstats(riche,rest,{'mean','gname'})

sedata=[ind rest riche];
[bootstat,bootsam]=bootstrp(100,@(x) [mean(x(:,3))],sedata);
std(bootstat)
[bootstat,bootsam]=bootstrp(100,@(x)[grpstats(x(:,3),x(:,1),{'mean'})],sedata);
std(bootstat)
[bootstat,bootsam]=bootstrp(100,@(x)[grpstats(x(:,3),x(:,2),{'mean'})],sedata);
std(bootstat)

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%washing machine
washe=standarderrors(x,y,[X(:,1:5) ones(n,1) X(:,7:10) ],n,k,w,p,inc,tyear,ind,rich)-standarderrors(x,y,[X(:,1:5) zeros(n,1) X(:,7:10) ],n,k,w,p,inc,tyear,ind,rich);
beep;

mean(washe)
[m,grp]=grpstats(washe,ind,{'mean','gname'})
[m,grp]=grpstats(washe,rest,{'mean','gname'})

sedata=[ind rest washe];
[bootstat,bootsam]=bootstrp(100,@(x) [mean(x(:,3))],sedata);
std(bootstat)
[bootstat,bootsam]=bootstrp(100,@(x)[grpstats(x(:,3),x(:,1),{'mean'})],sedata);
std(bootstat)
[bootstat,bootsam]=bootstrp(100,@(x)[grpstats(x(:,3),x(:,2),{'mean'})],sedata);
std(bootstat)

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%bathtub or showwer
bathe=standarderrors(x,y,[X(:,1:8) ones(n,1) X(:,10) ],n,k,w,p,inc,tyear,ind,rich)-standarderrors(x,y,[X(:,1:8) zeros(n,1) X(:,10) ],n,k,w,p,inc,tyear,ind,rich);
beep;

mean(bathe)
[m,grp]=grpstats(bathe,ind,{'mean','gname'})
[m,grp]=grpstats(bathe,rest,{'mean','gname'})

sedata=[ind rest bathe];
[bootstat,bootsam]=bootstrp(100,@(x) [mean(x(:,3))],sedata);
std(bootstat)
[bootstat,bootsam]=bootstrp(100,@(x)[grpstats(x(:,3),x(:,1),{'mean'})],sedata);
std(bootstat)
[bootstat,bootsam]=bootstrp(100,@(x)[grpstats(x(:,3),x(:,2),{'mean'})],sedata);
std(bootstat)

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%education
%this is a binary variable
edue=standarderrors(x,y,[X(:,1:9) ones(n,1) ],n,k,w,p,inc,tyear,ind,rich)-standarderrors(x,y,[X(:,1:9) zeros(n,1)],n,k,w,p,inc,tyear,ind,rich);
beep;

mean(edue)
[m,grp]=grpstats(edue,ind,{'mean','gname'})
[m,grp]=grpstats(edue,rest,{'mean','gname'})

sedata=[ind rest edue];
[bootstat,bootsam]=bootstrp(100,@(x) [mean(x(:,3))],sedata);
std(bootstat)
[bootstat,bootsam]=bootstrp(100,@(x)[grpstats(x(:,3),x(:,1),{'mean'})],sedata);
std(bootstat)
[bootstat,bootsam]=bootstrp(100,@(x)[grpstats(x(:,3),x(:,2),{'mean'})],sedata);
std(bootstat)

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%income
ince=standarderrors(x,y,X,n,k,w,p,inc+1,tyear,ind,rich)-W;
mean(ince)
[m,grp]=grpstats(ince,ind,{'mean','gname'})
[m,grp]=grpstats(ince,rest,{'mean','gname'})

sedata=[ind rest ince];
[bootstat,bootsam]=bootstrp(100,@(x) [mean(x(:,3))],sedata);
std(bootstat)
[bootstat,bootsam]=bootstrp(100,@(x)[grpstats(x(:,3),x(:,1),{'mean'})],sedata);
std(bootstat)
[bootstat,bootsam]=bootstrp(100,@(x)[grpstats(x(:,3),x(:,2),{'mean'})],sedata);
std(bootstat)

%%marginal effect for price
%Note this is different from the price elasticity which is calculated in a
%separate file

pe=standarderrors(x,y,X,n,k,w,p+1,inc,tyear,ind,rich)-W;
mean(pe)
[m,grp]=grpstats(pe,ind,{'mean','gname'})
[m,grp]=grpstats(pe,rest,{'mean','gname'})

sedata=[ind rest pe];
[bootstat,bootsam]=bootstrp(100,@(x) [mean(x(:,3))],sedata);
std(bootstat)
[bootstat,bootsam]=bootstrp(100,@(x)[grpstats(x(:,3),x(:,1),{'mean'})],sedata);
std(bootstat)
[bootstat,bootsam]=bootstrp(100,@(x)[grpstats(x(:,3),x(:,2),{'mean'})],sedata);
std(bootstat)



