
%%%Price elasticity
%This computes the results in Table 3 of the paper
%Note: because of the price change we need to compute a new virtual income

%%run but don't save
pelast=p*1.01;
n=length(tyear);
for i=1:n
    if p(i,1)==0
pelast(i,1)=1;
    end 
end

%%new virtual income
incelast(:,1)=inc(:,1);
incelast(:,2)=incelast(:,1)+(pelast(:,2)-pelast(:,1)).*w(:,1);
incelast(:,3)=incelast(:,2)+(pelast(:,3)-pelast(:,2)).*w(:,2);
incelast(:,4)=incelast(:,3)+(pelast(:,4)-pelast(:,3)).*w(:,3);
incelast(:,5)=incelast(:,4)+(pelast(:,5)-pelast(:,4)).*w(:,4);
incelast(:,6)=incelast(:,5)+(pelast(:,6)-pelast(:,5)).*w(:,5);
incelast(:,7)=incelast(:,6)+(pelast(:,7)-pelast(:,6)).*w(:,6);
incelast(:,8)=incelast(:,7)+(pelast(:,8)-pelast(:,7)).*w(:,7);

priceelast=((standarderrors(x,y,X,n,k,w,pelast,incelast,tyear,ind,rich)./W)-1)*100;  


mean(priceelast)
[m,grp]=grpstats(priceelast,ind,{'mean','gname'})
[m,grp]=grpstats(priceelast,rest,{'mean','gname'})
[m,grp]=grpstats(priceelast,rich,{'mean','gname'})


%Price elasticity by various groups (as in Table 3)
%bathtub
bath=X(:,9);
[m,grp]=grpstats(priceelast,bath,{'mean','gname'})


%number of persons
person=zeros(n,1);
for i=1:n
    if X(i,7)<=2
person(i,1)=1;
    end 
end
[m,grp]=grpstats(priceelast,person,{'mean','gname'})



%%washing machine
wash=X(:,6);
[m,grp]=grpstats(priceelast,wash,{'mean','gname'})

%%high school
high=X(:,10);
[m,grp]=grpstats(priceelast,high,{'mean','gname'})

%%income
poor=zeros(n,1);
for i=1:n
    if inc(i,1)<=5036
poor(i,1)=1;
    end 
end
[m,grp]=grpstats(priceelast,poor,{'mean','gname'})


%%%
%standard error of the price elasticity

sedata=[ind rest priceelast];
[bootstat,bootsam]=bootstrp(1000,@(x) [mean(x(:,3))],sedata);
std(bootstat)
[bootstat,bootsam]=bootstrp(100,@(x)[grpstats(x(:,3),x(:,1),{'mean'})],sedata);
std(bootstat)
[bootstat,bootsam]=bootstrp(100,@(x)[grpstats(x(:,3),x(:,2),{'mean'})],sedata);
std(bootstat)

%sanitation
sedata=[rich priceelast];
[bootstat,bootsam]=bootstrp(100,@(x)[grpstats(x(:,2),x(:,1),{'mean'})],sedata);
std(bootstat)


sedata=[high priceelast];
[bootstat,bootsam]=bootstrp(100,@(x)[grpstats(x(:,2),x(:,1),{'mean'})],sedata);
std(bootstat)

sedata=[wash priceelast];
[bootstat,bootsam]=bootstrp(100,@(x)[grpstats(x(:,2),x(:,1),{'mean'})],sedata);
std(bootstat)

sedata=[poor priceelast];
[bootstat,bootsam]=bootstrp(100,@(x)[grpstats(x(:,2),x(:,1),{'mean'})],sedata);
std(bootstat)

sedata=[person priceelast];
[bootstat,bootsam]=bootstrp(100,@(x)[grpstats(x(:,2),x(:,1),{'mean'})],sedata);
std(bootstat)

sedata=[bath priceelast];
[bootstat,bootsam]=bootstrp(100,@(x)[grpstats(x(:,2),x(:,1),{'mean'})],sedata);
std(bootstat)

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%%%%price elasticity by consumption group

breaks=[1 6 11 18 50];
concat=ordinal(y,{'Q1','Q2','Q3','Q4'},[],breaks);
concat2=double(concat)
sedata=[ind rest priceelast concat2];

[m,grp]=grpstats(priceelast,concat,{'mean','gname'})
[bootstat,bootsam]=bootstrp(100,@(x)[grpstats(x(:,3),{x(:,4)},{'mean'})],sedata);
std(bootstat)

[m,grp]=grpstats(priceelast,{concat,ind},{'mean','gname'}) 
[bootstat,bootsam]=bootstrp(100,@(x)[grpstats(x(:,3),{x(:,4),x(:,1)},{'mean'})],sedata);
std(bootstat)

[m,grp]=grpstats(priceelast,{concat,rest},{'mean','gname'})
[bootstat,bootsam]=bootstrp(100,@(x)[grpstats(x(:,3),{x(:,4),x(:,2)},{'mean'})],sedata);
std(bootstat)

%sanitation
sedata=[rich priceelast concat2];
[m,grp]=grpstats(priceelast,{concat,rich},{'mean','gname'})
[bootstat,bootsam]=bootstrp(100,@(x)[grpstats(x(:,2),{x(:,3),x(:,1)},{'mean'})],sedata);
std(bootstat)


sedata=[high priceelast concat2];
[m,grp]=grpstats(priceelast,{concat,high},{'mean','gname'})
[bootstat,bootsam]=bootstrp(100,@(x)[grpstats(x(:,2),{x(:,3),x(:,1)},{'mean'})],sedata);
std(bootstat)


sedata=[wash priceelast concat2];
[m,grp]=grpstats(priceelast,{concat,wash},{'mean','gname'})
[bootstat,bootsam]=bootstrp(100,@(x)[grpstats(x(:,2),{x(:,3),x(:,1)},{'mean'})],sedata);
std(bootstat)

sedata=[poor priceelast concat2];
[m,grp]=grpstats(priceelast,{concat,poor},{'mean','gname'})
[bootstat,bootsam]=bootstrp(100,@(x)[grpstats(x(:,2),{x(:,3),x(:,1)},{'mean'})],sedata);
std(bootstat)

sedata=[bath priceelast concat2];
[m,grp]=grpstats(priceelast,{concat,bath},{'mean','gname'})
[bootstat,bootsam]=bootstrp(100,@(x)[grpstats(x(:,2),{x(:,3),x(:,1)},{'mean'})],sedata);
std(bootstat)

sedata=[person priceelast concat2];
[m,grp]=grpstats(priceelast,{concat,person},{'mean','gname'})
[bootstat,bootsam]=bootstrp(100,@(x)[grpstats(x(:,2),{x(:,3),x(:,1)},{'mean'})],sedata);
std(bootstat)

%%%%%%%%%%end of price elasticity tables 

