function [aa] = sum7i(x,X,n,k,z,ind,inc);


%x starting values for the marginal prices
%X data
%z parameters from the estimation

%include revenue/expenditure (R) and total consumpiton (CC)
%corresponding to the baseline tariff year (either tyear 6 or tyear 8)
%computed by current.m
R= ;
CC= ;


bc=z(1:k);
bp=z(k+1);
by=z(k+2);

sn=z(end-1)^2;  %sn: sigma(eta)
s0=z(end)^2;  %s0: sigma(epsilon
sv=sqrt((s0^2)+(sn^2));  %sv: sigma(v)
corr=sn/sv;  %corr: rho

p(:,1)=ones(n,1)*x(1);
for i=1:n
    if ind(i,1)==1
        p(i,1)=0;
    end
end
p(:,2)=ones(n,1)*(x(1)+x(2));
p(:,3)=ones(n,1)*(x(1)+x(2)+x(3));
p(:,4)=ones(n,1)*(x(1)+x(2)+x(3)+x(4));
p(:,5)=ones(n,1)*(x(1)+x(2)+x(3)+x(4)+x(5));
p(:,6)=ones(n,1)*(x(1)+x(2)+x(3)+x(4)+x(5)+x(6));
p(:,7)=ones(n,1)*(x(1)+x(2)+x(3)+x(4)+x(5)+x(6)+x(7));

w(:,1)=ones(n,1)*6;
w(:,2)=ones(n,1)*12;
w(:,3)=ones(n,1)*18;
w(:,4)=ones(n,1)*24;
w(:,5)=ones(n,1)*30;
w(:,6)=ones(n,1)*42;

inc=inc(:,1);
inc(:,2)=inc(:,1)+(p(:,2)-p(:,1)).*w(:,1);
inc(:,3)=inc(:,2)+(p(:,3)-p(:,2)).*w(:,2);
inc(:,4)=inc(:,3)+(p(:,4)-p(:,3)).*w(:,3);
inc(:,5)=inc(:,4)+(p(:,5)-p(:,4)).*w(:,4);
inc(:,6)=inc(:,5)+(p(:,6)-p(:,5)).*w(:,5);
inc(:,7)=inc(:,6)+(p(:,7)-p(:,6)).*w(:,6);

wstar1=X*bc+bp*(p(:,1))+by*inc(:,1);
wstar2=X*bc+bp*(p(:,2))+by*inc(:,2);
wstar3=X*bc+bp*(p(:,3))+by*inc(:,3);
wstar4=X*bc+bp*(p(:,4))+by*inc(:,4);
wstar5=X*bc+bp*(p(:,5))+by*inc(:,5);
wstar6=X*bc+bp*(p(:,6))+by*inc(:,6);
wstar7=X*bc+bp*(p(:,7))+by*inc(:,7);



% FEASIBILITY AND SEGMENT VS. SEGMENT THRESHOLDS (theta_jk and eta_jk)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

theta11=w(:,1)-wstar1;  %these are theta_ij
theta12=w(:,1)-wstar2;
theta22=w(:,2)-wstar2;
theta23=w(:,2)-wstar3;
theta33=w(:,3)-wstar3;
theta34=w(:,3)-wstar4;
theta44=w(:,4)-wstar4; 
theta45=w(:,4)-wstar5;
theta55=w(:,5)-wstar5;
theta56=w(:,5)-wstar6;
theta66=w(:,6)-wstar6;
theta67=w(:,6)-wstar7;

up1s=theta11;
lo1k=theta11;
up1k=theta12;
lo2s=theta12;
up2s=theta22;
lo2k=theta22;
up2k=theta23;
lo3s=theta23;
up3s=theta33;
lo3k=theta33;
up3k=theta34;
lo4s=theta34;
up4s=theta44;
lo4k=theta44;
up4k=theta45;
lo5s=theta45;
up5s=theta55;
lo5k=theta55;
up5k=theta56;
lo6s=theta56;
up6s=theta66;
lo6k=theta66;
up6k=theta67;
lo7s=theta67;

wstar=[wstar1 wstar2 wstar3 wstar4 wstar5 wstar6 wstar7 ];

trunc=nanmin(-wstar,[],2)-bp/by; % trunc is etabar
tr2=normcdf(trunc/sn,0,1)+0.0000000001; %add small number to avoid dividing by zero below

pik=zeros(n,7); %the probability of each segment
zeta=zeros(n,7); %the expected consumption on each segment
lambda=zeros(n,7); %the probability of each kink

for i=1:n    
    pik(i,1)=normcdf(min(up1s(i,1),trunc(i,1))/sn)/tr2(i,1);
    pik(i,2)=max(0,(normcdf(min(up2s(i,1),trunc(i,1))/sn)-normcdf(min(lo2s(i,1),trunc(i,1))/sn)))/tr2(i,1);
    pik(i,3)=max(0,(normcdf(min(up3s(i,1),trunc(i,1))/sn)-normcdf(min(lo3s(i,1),trunc(i,1))/sn)))/tr2(i,1);
    pik(i,4)=max(0,(normcdf(min(up4s(i,1),trunc(i,1))/sn)-normcdf(min(lo4s(i,1),trunc(i,1))/sn)))/tr2(i,1);
    pik(i,5)=max(0,(normcdf(min(up5s(i,1),trunc(i,1))/sn)-normcdf(min(lo5s(i,1),trunc(i,1))/sn)))/tr2(i,1);
    pik(i,6)=max(0,(normcdf(min(up6s(i,1),trunc(i,1))/sn)-normcdf(min(lo6s(i,1),trunc(i,1))/sn)))/tr2(i,1);
    pik(i,7)=1-normcdf(min(lo7s(i,1),trunc(i,1))/sn)/tr2(i,1);
     
    lambda(i,1)=max(0,normcdf(min(up1k(i,1),trunc(i,1))/sn)-normcdf(min(lo1k(i,1),trunc(i,1))/sn))/tr2(i,1);
    lambda(i,2)=max(0,normcdf(min(up2k(i,1),trunc(i,1))/sn)-normcdf(min(lo2k(i,1),trunc(i,1))/sn))/tr2(i,1);
    lambda(i,3)=max(0,normcdf(min(up3k(i,1),trunc(i,1))/sn)-normcdf(min(lo3k(i,1),trunc(i,1))/sn))/tr2(i,1);
    lambda(i,4)=max(0,normcdf(min(up4k(i,1),trunc(i,1))/sn)-normcdf(min(lo4k(i,1),trunc(i,1))/sn))/tr2(i,1);
    lambda(i,6)=max(0,normcdf(min(up6k(i,1),trunc(i,1))/sn)-normcdf(min(lo6k(i,1),trunc(i,1))/sn))/tr2(i,1);
     
    zeta(i,1)=-normpdf(min(up1s(i,1),trunc(i,1))/sn)/pik(i,1)/tr2(i,1)*sn;
    zeta(i,2)=(normpdf(min(lo2s(i,1),trunc(i,1))/sn)-normpdf(min(up2s(i,1),trunc(i,1))/sn))/pik(i,2)/tr2(i,1)*sn;
    zeta(i,3)=(normpdf(min(lo3s(i,1),trunc(i,1))/sn)-normpdf(min(up3s(i,1)/sn,trunc(i,1))/sn))/pik(i,3)/tr2(i,1)*sn;
    zeta(i,4)=(normpdf(min(lo4s(i,1),trunc(i,1))/sn)-normpdf(min(up4s(i,1)/sn,trunc(i,1))/sn))/pik(i,4)/tr2(i,1)*sn;
    zeta(i,5)=(normpdf(min(lo5s(i,1),trunc(i,1))/sn)-normpdf(min(up5s(i,1)/sn,trunc(i,1))/sn))/pik(i,5)/tr2(i,1)*sn;
    zeta(i,6)=(normpdf(min(lo6s(i,1),trunc(i,1))/sn)-normpdf(min(up6s(i,1)/sn,trunc(i,1))/sn))/pik(i,6)/tr2(i,1)*sn;
    zeta(i,7)=(normpdf(min(lo7s(i,1),trunc(i,1))/sn)-normpdf(trunc(i,1)/sn))/pik(i,7)/tr2(i,1)*sn;
    
    W1(i,1)=(wstar1(i,1)+zeta(i,1)).*pik(i,1);
    W2(i,1)=(wstar2(i,1)+zeta(i,2)).*pik(i,2);
    W3(i,1)=(wstar3(i,1)+zeta(i,3)).*pik(i,3);
    W4(i,1)=(wstar4(i,1)+zeta(i,4)).*pik(i,4);
    W5(i,1)=(wstar5(i,1)+zeta(i,5)).*pik(i,5);
    W6(i,1)=(wstar6(i,1)+zeta(i,6)).*pik(i,6);
    W7(i,1)=(wstar7(i,1)+zeta(i,7)).*pik(i,7);
   
    W1k(i,1)=w(i,1).*lambda(i,1);
    W2k(i,1)=w(i,2).*lambda(i,2);
    W3k(i,1)=w(i,3).*lambda(i,3);
    W4k(i,1)=w(i,4).*lambda(i,4);
    W5k(i,1)=w(i,5).*lambda(i,5);
    W6k(i,1)=w(i,6).*lambda(i,6);
    

end


%NaN's are possible in W when a segment / kink has 0 probability.
%Therefore, we replace these with 0.
null=isnan(W1);
W1(null)=0;
null=isnan(W2);
W2(null)=0;
null=isnan(W3);
W3(null)=0;
null=isnan(W4);
W4(null)=0;
null=isnan(W5);
W5(null)=0;
null=isnan(W6);
W6(null)=0;
null=isnan(W7);
W7(null)=0;


null=isnan(W1k);
W1k(null)=0;
null=isnan(W2k);
W2k(null)=0;
null=isnan(W3k);
W3k(null)=0;
null=isnan(W4k);
W4k(null)=0;
null=isnan(W5k);
W5k(null)=0;
null=isnan(W6k);
W6k(null)=0;

W=W1+W2+W3+W4+W5+W6+W7+W1k+W2k+W3k+W4k+W5k+W6k;


%Expected utilities on segments

%indirect utilities, times by^2 for scale
V1=by^2*exp(-by*p(:,1)).*(inc(:,1)+(bp/by)*p(:,1)+(bp/(by^2))+X*(bc/by)+zeta(:,1)/by);
V2=by^2*exp(-by*p(:,2)).*(inc(:,2)+(bp/by)*p(:,2)+(bp/(by^2))+X*(bc/by)+zeta(:,2)/by);
V3=by^2*exp(-by*p(:,3)).*(inc(:,3)+(bp/by)*p(:,3)+(bp/(by^2))+X*(bc/by)+zeta(:,3)/by);
V4=by^2*exp(-by*p(:,4)).*(inc(:,4)+(bp/by)*p(:,4)+(bp/(by^2))+X*(bc/by)+zeta(:,4)/by);
V5=by^2*exp(-by*p(:,5)).*(inc(:,5)+(bp/by)*p(:,5)+(bp/(by^2))+X*(bc/by)+zeta(:,5)/by);
V6=by^2*exp(-by*p(:,6)).*(inc(:,6)+(bp/by)*p(:,6)+(bp/(by^2))+X*(bc/by)+zeta(:,6)/by);
V7=by^2*exp(-by*p(:,7)).*(inc(:,7)+(bp/by)*p(:,7)+(bp/(by^2))+X*(bc/by)+zeta(:,7)/by);

%multiplied by the probabilities at the segments
h1=V1.*pik(:,1);
h2=V2.*pik(:,2);
h3=V3.*pik(:,3);
h4=V4.*pik(:,4);
h5=V5.*pik(:,5);
h6=V6.*pik(:,6);
h7=V7.*pik(:,7);

%V, therefore h, can have NaN's when probability of a segment is 0. Replace
%these with 0:
null=isnan(h1);
h1(null)=0;
null=isnan(h2);
h2(null)=0;
null=isnan(h3);
h3(null)=0;
null=isnan(h4);
h4(null)=0;
null=isnan(h5);
h5(null)=0;
null=isnan(h6);
h6(null)=0;
null=isnan(h7);
h7(null)=0;

%Expected utilities at the kink points

x1=inc(:,1)-p(:,1).*w(:,1);
x2=inc(:,2)-p(:,2).*w(:,2);
x3=inc(:,3)-p(:,3).*w(:,3);
x4=inc(:,4)-p(:,4).*w(:,4);
x5=inc(:,5)-p(:,5).*w(:,5);
x6=inc(:,6)-p(:,6).*w(:,6);

%part of utility that does not depend on eta, times by^2 for scale
A1=(by*w(:,1)+bp).*exp(by*(by*x1-w(:,1)+X*bc)./(by*w(:,1)+bp));
A2=(by*w(:,2)+bp).*exp(by*(by*x2-w(:,2)+X*bc)./(by*w(:,2)+bp));
A3=(by*w(:,3)+bp).*exp(by*(by*x3-w(:,3)+X*bc)./(by*w(:,3)+bp));
A4=(by*w(:,4)+bp).*exp(by*(by*x4-w(:,4)+X*bc)./(by*w(:,4)+bp));
A5=(by*w(:,5)+bp).*exp(by*(by*x5-w(:,5)+X*bc)./(by*w(:,5)+bp));
A6=(by*w(:,6)+bp).*exp(by*(by*x6-w(:,6)+X*bc)./(by*w(:,6)+bp));

%expected utility given consumption at the kinks

B1=by./(by*w(:,1)+bp);
B2=by./(by*w(:,2)+bp);
B3=by./(by*w(:,3)+bp);
B4=by./(by*w(:,4)+bp);
B5=by./(by*w(:,5)+bp);
B6=by./(by*w(:,6)+bp);

E1=exp(sn^2*B1.^2/2).*(normcdf(B1*sn-min([trunc,lo1k],[],2)/sn)-normcdf(B1*sn-min([trunc,up1k],[],2)/sn))./(normcdf(min([trunc,up1k],[],2)/sn)-normcdf(min([trunc,lo1k],[],2)/sn));
E2=exp(sn^2*B2.^2/2).*(normcdf(B2*sn-min([trunc,lo2k],[],2)/sn)-normcdf(B2*sn-min([trunc,up2k],[],2)/sn))./(normcdf(min([trunc,up2k],[],2)/sn)-normcdf(min([trunc,lo2k],[],2)/sn));
E3=exp(sn^2*B3.^2/2).*(normcdf(B3*sn-min([trunc,lo3k],[],2)/sn)-normcdf(B3*sn-min([trunc,up3k],[],2)/sn))./(normcdf(min([trunc,up3k],[],2)/sn)-normcdf(min([trunc,lo3k],[],2)/sn));
E4=exp(sn^2*B4.^2/2).*(normcdf(B4*sn-min([trunc,lo4k],[],2)/sn)-normcdf(B4*sn-min([trunc,up4k],[],2)/sn))./(normcdf(min([trunc,up4k],[],2)/sn)-normcdf(min([trunc,lo4k],[],2)/sn));
E5=exp(sn^2*B5.^2/2).*(normcdf(B5*sn-min([trunc,lo5k],[],2)/sn)-normcdf(B5*sn-min([trunc,up5k],[],2)/sn))./(normcdf(min([trunc,up5k],[],2)/sn)-normcdf(min([trunc,lo5k],[],2)/sn));
E6=exp(sn^2*B6.^2/2).*(normcdf(B6*sn-min([trunc,lo6k],[],2)/sn)-normcdf(B6*sn-min([trunc,up6k],[],2)/sn))./(normcdf(min([trunc,up6k],[],2)/sn)-normcdf(min([trunc,lo6k],[],2)/sn));

h1k=A1.*E1.*lambda(:,1);
h2k=A2.*E2.*lambda(:,2);
h3k=A3.*E3.*lambda(:,3);
h4k=A4.*E4.*lambda(:,4);
h5k=A5.*E5.*lambda(:,5);
h6k=A6.*E6.*lambda(:,6);

null=isnan(h1k);
h1k(null)=0;
null=isnan(h2k);
h2k(null)=0;
null=isnan(h3k);
h3k(null)=0;
null=isnan(h4k);
h4k(null)=0;
null=isnan(h5k);
h5k(null)=0;
null=isnan(h6k);
h6k(null)=0;

H=h1+h2+h3+h4+h5+h6+h7+h1k+h2k+h3k+h4k+h5k+h6k;
aa=-(sum(H)/1000+6.4145)*10000000;
